%error = ForceRequiredAddOn("Weapon_Gun");

if(%error == $Error::AddOn_Disabled)
{
   GunItem.uiName = "";
}
%error = ForceRequiredAddOn("Player_No_Jet");

if(%error == $Error::AddOn_Disabled)
{
   PlayerNoJet.uiName = "";
}
datablock AudioProfile(SwolMagnumFireSound)
{
   filename    = "./MagnumFire.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(SwolMagnumFireAltSound)
{
   filename    = "./MagnumFireAlt.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(SwolMagnumClickSound)
{
   filename    = "./MagnumClick.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock PlayerData(PlayerMagnumStumble : PlayerNoJet)
{
	maxForwardSpeed = 4;
   	maxBackwardSpeed = 3;
   	maxSideSpeed = 3;

	maxForwardCrouchSpeed = 0;
   	maxBackwardCrouchSpeed = 0;
   	maxSideCrouchSpeed = 0;
   	
	jumpForce = 7 * 90;
   	jumpDelay = 25;
	uiName = "";
};
datablock ParticleData(SwolMagnumTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 120;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "1 1 0 1";
	colors[1]	= "1 1 0.4 1";
	colors[2]	= "1 1 1 1";
	sizes[0]	= 0.2;
	sizes[1]	= 0.15;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.5;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(SwolMagnumTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = SwolMagnumTrailParticle;

   useEmitterColors = true;
};
AddDamageType("SwolMagnum",   '<bitmap:add-ons/Weapon_Magnum/CI_Magnum> %1',    '%2 <bitmap:add-ons/Weapon_Magnum/CI_Magnum> %1',0.2,1);
datablock ProjectileData(SwolMagnum_projectile : gunProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 50;
   directDamageType    = $DamageType::SwolMagnum;
   radiusDamageType    = $DamageType::SwolMagnum;
   particleEmitter     = SwolMagnumTrailEmitter;
   explosion = GunExplosion;
   uiName = "Magnum Bullet";
};

//////////
// item //
//////////
datablock ItemData(SwolMagnumItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Magnum.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Magnum";
	iconName = "./icon_Magnum";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = SwolMagnumImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SwolMagnumImage)
{
   // Basic Item properties
   shapeFile = "./Magnum.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0.1 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = SwolMagnumItem;
   ammo = " ";
   projectile = SwolMagnum_projectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = gunItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.66;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "ClickHammer";
	stateAllowImageChange[1]         = true;
	
	stateName[2]					= "ClickHammer";
	stateTransitionOnTimeout[2]     = "Fire";
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[3]			= true;
	stateTimeoutValue[2]            = 0.012;

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Smoke";
	stateTimeoutValue[3]            = 0.14;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateEmitter[3]					= gunFlashEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";

	stateName[4] 					= "Smoke";
	stateEmitter[4]					= gunSmokeEmitter;
	stateEmitterTime[4]				= 0.05;
	stateEmitterNode[4]				= "muzzleNode";
	stateTimeoutValue[4]            = 0.1;
	stateTransitionOnTimeout[4]     = "CockDelay";
	
	stateName[5] 					= "CockDelay";	
	stateTimeoutValue[5]            = 0.13;
	stateWaitForTimeout[5]			= true;
	stateTransitionOnTimeout[5]     = "Cock";
	
	stateName[6] 					= "Cock";
	stateTimeoutValue[6]            = 0.04;
	stateWaitForTimeout[6]			= true;
	stateSequence[6]                = "Cock";
	stateTransitionOnTimeout[6]     = "Revolve";
	stateSound[6]					= SwolMagnumClickSound;
	
	stateName[7]			= "ResetShot";
	stateTransitionOnTriggerUp[7]     = "Ready";
	
	stateName[8]					= "Revolve";
	stateSequence[8]				= "Revolve";
	stateTimeoutValue[8]            = 0.15;
	stateWaitForTimeout[6]			= true;
	stateTransitionOnTimeout[8]     = "ResetShot";
};
function SwolMagnumImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, plant);
		
	%rand = getRandom(0,1);
	if(!%rand)
	serverplay3d("SwolMagnumFireAltSound", %obj.getHackPosition() SPC "0 0 1 0");
	else
	serverplay3d("SwolMagnumFireSound", %obj.getHackPosition() SPC "0 0 1 0");	
		
	Parent::onFire(%this,%obj,%slot);	
}
function SwolMagnum_projectile::onCollision(%this, %obj, %col, %vec, %vecLen)
{
	parent::onCollision(%this, %obj, %col, %vec, %vecLen);
	if(%col.getClassName() $= "player" || %col.getClassName() $= "aiPlayer")
	{
		if(minigameCanDamage(%col,%obj))
		{
			if(%col.getDamagePercent() < 1.0)
			{
				cancel(%col.magnumStumbleSched);
				%col.oldPlayerType = %col.getDatablock();
				%col.setDataBlock(PlayerMagnumStumble);
				%col.magnumStumbleSched = %col.schedule(800,resetSwolMagnumStumble,%col);
			}
		}
	}
}
function Player::resetSwolMagnumStumble(%this)
{
	if(!isObject(%this))
	return;
	if(%this.getDamagePercent() >= 1.0)
	return;
	
	cancel(%obj.magnumStumbleSched);
	eval(%this @ ".setDatablock(" @ %this.oldPlayerType @ ");");
}
